      double precision MassFd(3),MassFe(3),MassFu(3),MFu2(3),MFe2(3),MFd2(3),
     &                 MassHpm(2),MassHpm2(2),Masshh(6),Masshh2(6),MSU2(6),
     &                 MSd2(6),MSe2(6),MSv2(3),MNeu(5),MNeu2(5),MCha2(2),
     &                 MW2,MZ2,MHp2,CB,SB,TB,CB2,SB2,CW,SW,CW2,SW2,C2W,S2W,
     &                 Pi2,Pi,sqrt2,fac,C2B,ZP(2,2)
      common /MassPara/MassFd,MassFe,MassFu,MFu2,MFe2,MFd2,
     &                 MassHpm,MassHpm2,Masshh,Masshh2,MSU2,
     &                 MSd2,MSe2,MSv2,MNeu,MNeu2,MCha2,
     &                 MW2,MZ2,MHp2,CB,SB,TB,CB2,SB2,CW,SW,CW2,SW2,C2W,S2W,
     &                 Pi2,Pi,sqrt2,fac,C2B,ZP

      double precision C2HmHp(2,2,2,2),CHmU3U1(2),CHmU3U2(2)
      common /CLCHiggs/C2HmHp,CHmU3U1,CHmU3U2


      double complex  ChHpWmA(6,2),ChHmWpA(2,6),ChHpWmZ(6,2),
     &                ChHmWpZ(2,6),ChhWmWp(6,6),ChhAZ(6,6),ChhZZ(6,6),
     &                ChHpWm(6,2),ChHmWp(2,6),ChhZ(6,6),ChWmWp(6),
     &                ChZZ(6),ChSdmSdp(6,6,6),ChSemSep(6,6,6),
     &                ChSupSum(6,6,6),ChSvSvconj(6),ChHmHp(2,2,6),
     &                ChhSemSep(6,6,6,6),ChhSvSvconj(6,6),
     &                ChhHmHp(2,6,2,6),ChhSupSum(6,6,6,6),
     &                ChhSdmSdp(6,6,6,6),CLhChapCham(2,2,6),
     &                CRhChapCham(2,2,6),CLhFepFem(3,3,6),
     &                CRhFepFem(3,3,6),CLhFdpFdm(3,3,6),
     &                CRhFdpFdm(3,3,6),CLhFumFup(3,3,6),
     &                CRhFumFup(3,3,6),ChU3U3(6),ChU2U2(6),ChU4U4(6),
     &                Chhh(6,6,6),Chhhh(6,6,6,6),CLhChiChi(5,5,6),
     &                CRhChiChi(5,5,6),CHmHpSvSv(3,2,3,2),
     &                CHmHpSdmSdp(6,2,6,2),CHmHpSupSum(6,2,6,2),
     &                CHmHpSemSep(6,2,6,2),CHmSepSv(3,6,2),
     &                CHpSemSv(6,3,2),CHmSupSdp(6,6,2),
     &                CHpSumSdm(6,6,2),CLHpChiCha(5,2,2),
     &                CRHpChiCha(5,2,2),CLHmChiCha(2,5,2),
     &                CRHmChiCha(2,5,2)

      common /coupl/ ChHpWmA,ChHmWpA,ChHpWmZ,ChHmWpZ,ChhWmWp,
     &               ChhAZ,ChhZZ,ChHpWm,ChHmWp,ChhZ,ChWmWp,ChZZ,
     &               ChSdmSdp,ChSemSep,ChSupSum,ChSvSvconj,ChHmHp,
     &               ChhSemSep,ChhSvSvconj,ChhHmHp,ChhSupSum,ChhSdmSdp,
     &               CLhChapCham,CRhChapCham,CLhFepFem,CRhFepFem,
     &               CLhFdpFdm,CRhFdpFdm,CLhFumFup,CRhFumFup,ChU3U3,
     &               ChU2U2,ChU4U4,Chhh,Chhhh,CLhChiChi,CRhChiChi,
     &               CHmHpSvSv,CHmHpSdmSdp,CHmHpSupSum,CHmHpSemSep,
     &               CHmSepSv,CHpSemSv,CHmSupSdp,CHpSumSdm,CRHpChiCha,
     &               CLHpChiCha,CRHmChiCha,CLHmChiCha


      double complex cchinusnu(5,3),cchidmsdpR(5,3,6),cchidmsdpL(5,3,6),
     &               cchiupsumR(5,3,6),cchiupsumL(5,3,6),cchitaustauR(5,3,6),
     &               cchitaustauL(5,3,6),CF12AL(2,2),CF12AR(2,2),ctauchastauL(3,5,3)
     &               ,ctauchastauR(3,5,3),cupchapsdL(5,3,6),cupchapsdR(5,3,6)
     &               ,CF12F1S12(5,3,6),cdmchapsuL(3,5,6),cdmchapsuR(3,5,6)

      common /CLhXX_decay/cchinusnu,cchidmsdpR,cchidmsdpL,cchiupsumR,
     &               cchiupsumL,cchitaustauR,cchitaustauL,CF12AL,CF12AR,ctauchastauL
     &               ,ctauchastauR,cupchapsdL,cupchapsdR,CF12F1S12,
     &               cdmchapsuL,cdmchapsuR

      double complex   CHpHmZ,CSvSvZ,ctautauZL,ctautauZR,cuuZL,cuuZR,CddZL,CddZR,
     &                 CWWZ,CHmWpZ(2),CHpHmZZ(2,2),CSemSepZ(6,6),
     &                 CsupsumZ(6,6),csdmsdpZ(6,6),CSvSvZZ,CSuSuZZ(6,6),CSdSdZZ(6,6),
     &                 CSeSeZZ(6,6),CF11ZR(5,5),CF11ZL(5,5),CF12ZL(2,2),CF12ZR(2,2)        
 

      common/CLhZZ_decay/CHpHmZ,CSvSvZ,ctautauZL,ctautauZR,cuuZL,cuuZR,CddZL,CddZR,
     &                 CWWZ,CHmWpZ,CHpHmZZ,CSemSepZ,
     &                 CsupsumZ,csdmsdpZ,CSvSvZZ,CSuSuZZ,CSdSdZZ,
     &                 CSeSeZZ,CF11ZR,CF11ZL,CF12ZL,CF12ZR

      double complex   CupdmWp,CWWA,CHmWpA(2),CLF12F11W(2,5),CRF12F11W(2,5),CsesvW(6,3),
     &                 CsdsuW(6,6),CHmHpWW(2,2),CSeSeWW(6,6),CSuSuWW(6,6),CSdSdWW(6,6),
     &                 ChU2U1(6)

      common/CLhWW_decay/CupdmWp,CWWA,CHmWpA,CLF12F11W,CRF12F11W,CsesvW,
     &                 CsdsuW,CHmHpWW,CSeSeWW,CSuSuWW,CSdSdWW,ChU2U1

       double complex ChHmSupSdm(6,2,6,6),ChHpSumSdp(6,2,6,6),CSu2Sv2(6,6,3),
     &                CSu2Se2(6,6,6,6),CSd2Se2(6,6,6,6),CSd2Sv2(6,6,3),
     &                CSu4p1(6,6,6,6),CSu4p2(6,6,6,6),CSu2Sd2p1(6,6,6,6),
     &                CSu2Sd2p2(6,6,6,6),CSd4p1(6,6,6,6),CSd4p2(6,6,6,6),
     &                CSu4p1QCD(6,6,6,6),CSu4p2QCD(6,6,6,6),CSu2Sd2p1QCD(6,6,6,6),
     &                CSu2Sd2p2QCD(6,6,6,6),CSd4p1QCD(6,6,6,6),CSd4p2QCD(6,6,6,6),
     &                CF15usuL(3,6),CF15usuR(3,6),CF15dsdL(3,6),CF15dsdR(3,6),
     &                dChSupSum(6,6,6),dChSdmSdp(6,6,6),dChSupSumQCD(6,6,6),
     &                dChSdmSdpQCD(6,6,6)

      common/CLhstst_decay/ChHmSupSdm,ChHpSumSdp,CSu2Sv2,CSu2Se2,
     &                CSd2Se2,CSd2Sv2,CSu4p1,CSu4p2,CSu2Sd2p1,
     &                CSu2Sd2p2,CSd4p1,CSd4p2,CSu4p1QCD,CSu4p2QCD,
     &                CSu2Sd2p1QCD,CSu2Sd2p2QCD,CSd4p1QCD,CSd4p2QCD,
     &                CF15usuL,CF15usuR,CF15dsdL,CF15dsdR,
     &                dChSupSum,dChSdmSdp,dChSupSumQCD,dChSdmSdpQCD


       double complex CtbHpR(3,3,2),CtbHpL(3,3,2),CtbWp(3,3),CbtWm(3,3),CtaunuHpR(3,2)
       common/CLCHtb_decay/CtbHpR,CtbHpL,CtbWp,CbtWm,CtaunuHpR

       double complex ChHmSvSe(6,2,3,6),ChHpSvSe(6,2,3,6),CSdSvSeSt(6,3,6,6),CSe2Sv2(6,6,3,3),
     &                CSe4(6,6,6,6)
       common/CLCHtb_decay/ ChHmSvSe,ChHpSvSe,CSdSvSeSt,CSe2Sv2,CSe4
